
Redmine - Patch #31855

Speed up workflow edit page rendering

2019-08-06 22:02 - Felix Schäfer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 4.1.0   

Description

Currently the list of WorkflowTransitions workflows is scanned twice (#detect in app/views/workflows/_form.html.erb, select in

app/helpers/workflows_helper.rb) for each possible Status pair shown on the workflow edit page (the number of status pairs is itself

quadratic with the number of statuses). This leads to the rendering time for this page to be quadratic with the number of Status pairs.

The patch provided in the next update calculates all required data only once for the page instead of once for each Status pair. In a

test with 90 issue statuses in development mode on a laptop the total rendering time for the workflow edit page was changed from

~103 seconds before the patch to ~2,5s with the patch.

Associated revisions

Revision 18373 - 2019-08-17 04:23 - Go MAEDA

Speed up workflow edit page rendering (#31855).

Patch by Felix Schäfer.

History

#1 - 2019-08-06 22:03 - Felix Schäfer

- File 31855.patch added

Here is the patch.

#2 - 2019-08-06 23:51 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2019-08-12 06:31 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

#4 - 2019-08-17 04:25 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. It improves the rendering speed significantly. Thanks!

Files

31855.patch 1.79 KB 2019-08-06 Felix Schäfer
